freeslot("MT_PUNCHHITBOX","MT_ELECBALL","sfx_boost2","sfx_arspen","sfx_stmpg","sfx_stmps","sfx_rblsr1","sfx_rblsr3","MT_RUBYFUME")

if srb2p return end

sfxinfo[sfx_boost2].caption = "Boost"
sfxinfo[sfx_arspen].caption = "Double jump"
sfxinfo[sfx_stmpg].caption = "Stomp land"
sfxinfo[sfx_stmps].caption = "Stomp start"
sfxinfo[sfx_rblsr1].caption = "Electroball shot"
sfxinfo[sfx_rblsr3].caption = "Electroball hit a wall"

addHook("PlayerSpawn", function(player)
	player.thhkready = false
	player.thhkpressed = false
	player.spinready = false
	player.spinpressed = false
	player.fireread = false
	player.firepressed = false
	player.c1ready = false
	player.c1pressed = false
	player.c1released = false
	player.airt = 0
	player.hominged = false
	player.homingtimer = 0
	player.punchpause = 0
	player.elecharge = 25
	player.rhythmvar = 0
	player.boostin = false
	player.stompin = false
	player.stompspdx = 0
	player.stompspdy = 0
	player.c2switch = false
	player.retfuse = 0
end)

addHook("PlayerThink", function(player)
	if player.mo.skin ~= "ruby" then
		player.otherskin = true
		return
	end
	if player.powers[pw_nocontrol] then
		return
	end
	
	//buttons
	if (player.cmd.buttons & BT_JUMP) then
		if (player.thhkready) then
			player.thhkpressed = true
		else
			player.thhkpressed = false
		end
		player.thhkready = false
	else
		player.thhkpressed = false
		player.thhkready = true
	end
	
	if (player.cmd.buttons & BT_SPIN) then
		if (player.spinready) then
			player.spinpressed = true
		else
			player.spinpressed = false
		end
		player.spinready = false
	else
		player.spinpressed = false
		player.spinready = true
	end
	
	if (player.cmd.buttons & BT_ATTACK) then
		if (player.fireready) then
			player.firepressed = true
		else
			player.firepressed = false
		end
		player.fireready = false
	else
		player.firepressed = false
		player.fireready = true
	end
	
	if (player.cmd.buttons & BT_CUSTOM1) then
		if (player.c1ready) then
			player.c1pressed = true
		else
			player.c1pressed = false
		end
		player.c1ready = false
		player.c1released = false
	else
		if not (player.c1ready) then
			player.c1released = true
		else
			player.c1released = false
		end
		player.c1ready = true
		player.c1pressed = false
	end
	
	if player.stompin then
		if player.mo.state == S_PLAY_SPRING or P_IsObjectInGoop(player.mo) then
			player.stompin = false
		end
		
		player.mo.state = S_PLAY_FALL
		
		player.mo.momx = $ / 3 * 2 //player.stompspdx
		player.mo.momy = $ / 3 * 2 //player.stompspdy
		player.mo.momz = -45*player.mo.scale*P_MobjFlip(player.mo)
		
		if player.mo.subsector and player.mo.subsector.valid -- (from mario mod) 
		and player.mo.subsector.sector and player.mo.subsector.sector.valid
			for fof in player.mo.subsector.sector.ffloors()
				if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
				if not (fof.flags & FF_BUSTUP) -- Is it bustable?
				and not (fof.flags & FF_MARIO and fof.flags & FF_SHATTERBOTTOM) continue end
						
				if player.mo.z + player.mo.momz + player.mo.height < fof.bottomheight continue end -- Are we too low?
				if player.mo.z + player.mo.momz > fof.topheight continue end -- Are we too high?  
				
				EV_CrumbleChain(fof) -- Crumble
				if fof.master.flags & ML_EFFECT5
					P_LinedefExecute(P_AproxDistance(fof.master.dx, fof.master.dy)>>FRACBITS, player.mo, fof.target)
				end
			end
		end
	end
	
	
	if P_IsObjectOnGround(player.mo) then
		player.airt = 0
		player.hominged = false
		player.doublejumped = false
		if player.stompin then
			S_StartSound(player.mo,sfx_stmpg)
		end
		player.stompin = false
	else
		player.airt = player.airt + 1
		if player.mo.momz <= 0 then
			player.pflags = $ | PF_JUMPED
		end
	end
	
	if (not P_IsObjectOnGround(player.mo)) and player.airt > 3 and not (player.pflags & PF_THOKKED) and (player.pflags & PF_JUMPED) and player.punchpause <= 0 and not player.stompin then
		if player.spinpressed and player.elecharge >= 15 then
			player.stompin = true
			player.elecharge = $ - 15
			player.stompspdx = player.mo.momx / 8
			player.stompspdx = player.mo.momy / 8
			S_StartSound(player.mo,sfx_stmps)
		else
			player.target = P_LookForEnemies(player, true, false)
			if player.target and player.elecharge > 25 then
				P_SpawnLockOn(player, player.target, S_LOCKON3)
				if player.thhkpressed then
					player.pflags = $|PF_THOKKED
					player.hominged = true
					player.homingtimer = 180
					player.elecharge = $ - 25
					player.mo.state = S_PLAY_ROLL
					S_StartSound(player.mo,sfx_thok)
				else
					if player.firepressed then
						if (player.cmd.buttons & BT_CUSTOM2) then
							player.punchpause = 15
							player.elecharge = $ - 25
							player.elecball = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_ELECBALL)
							player.elecball.owner = player.mo
							player.elecball.targer = player.target
							
							player.elecball.angle = R_PointToAngle2(player.elecball.x,player.elecball.y,player.target.x,player.target.y)
							P_Thrust(player.mo,player.elecball.angle,-15*player.mo.scale)
							player.elecball.vangle = R_PointToAngle2(0,player.elecball.z,FixedHypot(player.target.x-player.elecball.x,player.target.y-player.elecball.y),player.target.z)
							player.elecball.momx = 90 * FixedMul(cos(player.elecball.angle), cos(player.elecball.vangle))
							player.elecball.momy = 90 * FixedMul(sin(player.elecball.angle), cos(player.elecball.vangle))
							player.elecball.momz = 90 * sin(player.elecball.vangle)
							player.elecball.oldmomx = player.elecball.momx
							player.elecball.oldmomy = player.elecball.momy
							player.elecball.oldmomz = player.elecball.momz
							
							S_StartSound(player.mo,sfx_rblsr1)
						else
							player.punchpause = 15
							player.elecharge = $ - 25
							player.elecball = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_ELECBALL)
							player.elecball.owner = player.mo
							P_Thrust(player.mo,player.mo.angle,-15*player.mo.scale)
							
							player.elecball.angle = player.mo.angle
							player.elecball.vangle = 0
							player.elecball.momx = 90 * cos(player.elecball.angle)
							player.elecball.momy = 90 * sin(player.elecball.angle)
							player.elecball.momz = 0
							player.elecball.oldmomx = player.elecball.momx
							player.elecball.oldmomy = player.elecball.momy
							player.elecball.oldmomz = player.elecball.momz
							
							S_StartSound(player.mo,sfx_rblsr1)
						end
					end
				end
			else
				if player.thhkpressed and not player.doublejumped then
					player.doublejumped = true
					player.mo.momx = $ / 5 * 4
					player.mo.momy = $ / 5 * 4
					player.mo.momz = player.mo.scale * 9*P_MobjFlip(player.mo)
					if (player.mo.eflags & MFE_UNDERWATER) then
						player.mo.momz = $ / 2
					end
					player.mo.state = S_PLAY_ROLL
					S_StartSound(player.mo,sfx_arspen)
				end
				if player.firepressed and player.elecharge > 25 then
					player.punchpause = 15
					player.elecharge = $ - 25
					player.elecball = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_ELECBALL)
					player.elecball.owner = player.mo
					P_Thrust(player.mo,player.mo.angle,-15*player.mo.scale)
					
					player.elecball.angle = player.mo.angle
					player.elecball.vangle = 0
					player.elecball.momx = 90 * cos(player.elecball.angle)
					player.elecball.momy = 90 * sin(player.elecball.angle)
					player.elecball.momz = 0
					player.elecball.oldmomx = player.elecball.momx
					player.elecball.oldmomy = player.elecball.momy
					player.elecball.oldmomz = player.elecball.momz
					
					S_StartSound(player.mo,sfx_rblsr1)
				end
			end
		end
	end
	
	if player.state == S_PLAY_SPRING then
		player.hominged = false
	end
	if player.hominged then
		player.powers[pw_nocontrol] = 1
		if player.target and player.target.valid and player.target.health then
			P_HomingAttack(player.mo, player.target)
			player.mo.momx = $ * 2
			player.mo.momy = $ * 2
			player.mo.momz = $ * 2
		else
			player.hominged = false
			player.doublejumped = false
			player.pflags = $1 & ~PF_THOKKED
			player.mo.momx = $ / 8
			player.mo.momy = $ / 8
			player.mo.momz = player.mo.scale * 10*P_MobjFlip(player.mo)
			player.mo.state = S_PLAY_JUMP
			if (player.mo.eflags & MFE_UNDERWATER) then
				player.mo.momz = $ / 2
			end
			player.powers[pw_nocontrol] = 0
		end
		player.homingtimer = $ - 1
		if player.homingtimer <= 0 then
			player.hominged = false
		end
	end
	
	if P_IsObjectOnGround(player.mo) and player.firepressed and player.punchpause <= 0 and not (player.pflags & PF_SPINNING) then
		player.punchpause = 15
		player.punchhitbox = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_PUNCHHITBOX)
		player.punchhitbox.owner = player.mo
		P_Thrust(player.mo,player.mo.angle,15*player.mo.scale)
		S_StartSound(player.mo,sfx_cdfm39)
	end
	if player.punchpause > 0 then
		player.powers[pw_nocontrol] = 1
		player.punchpause = $ - 1
		player.mo.state = S_RUBY_PNCH
	end
	
	player.rhythmvar = $ - 1
	if player.rhythmvar <= 0 then
		player.rhythmvar = 10
		player.elecharge = $ + 1
	end
	if player.elecharge > 500 then
		player.elecharge = 500
	end
	
	if player.c1pressed and not player.stompin and player.punchpause <= 0 then
		if player.elecharge > 14 then
			player.boostin = true
			player.elecharge = $ - 10
			S_StartSound(player.mo,sfx_boost2)
		/*else
			if not P_IsObjectOnGround(player.mo) then
				P_InstaThrust(player.mo,player.mo.angle,35*player.mo.scale)
				player.thokfx = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_THOK)
				player.thokfx.destscale = player.mo.scale
				player.thokfx.scale = player.thokfx.destscale
				player.thokfx.color = player.mo.color
				S_StartSound(player.mo,sfx_thok)
			end*/
		end
	end
	if player.boostin then
		P_InstaThrust(player.mo,player.mo.angle,75*player.mo.scale)
		player.mo.momz = $ * 4 / 5
		if P_IsObjectOnGround(player.mo) then
			player.mo.state = S_PLAY_RUN
		else
			player.mo.state = S_PLAY_ROLL
		end
		
		local fumefx = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z+player.mo.scale*4,MT_RUBYFUME)
		fumefx.tracer = player.mo
		fumefx.destscale = 0
		fumefx.scale = player.mo.scale
		fumefx.color = SKINCOLOR_ORANGE
		fumefx.sizemult = 3
		fumefx.sizedec = 4
		fumefx.colorized = true
		
		local needfx = false
		if player.fumefx then
			if player.fumefx.valid then
				player.fumefx.fuse = 15
				P_SetOrigin(player.fumefx,
							player.mo.x+player.mo.momx/4,
							player.mo.y+player.mo.momy/4,
							player.mo.z+player.mo.scale*5)
				player.fumefx.momx = player.mo.momx
				player.fumefx.momy = player.mo.momy
				player.fumefx.momz = player.mo.momz
			else
				needfx = true
			end
		else
			needfx = true
		end
		if needfx then
			player.fumefx = P_SpawnMobj(player.mo.x+player.mo.momx/4,player.mo.y+player.mo.momy/4,player.mo.z+player.mo.scale*5,MT_RUBYFUME)
			player.fumefx.tracer = player.mo
			player.fumefx.destscale = 0
			player.fumefx.scale = player.mo.scale*2
			player.fumefx.color = SKINCOLOR_ORANGE
			player.fumefx.sizemult = 1
			player.fumefx.sizedec = 1
			player.fumefx.fuse = 15
			player.fumefx.colorized = true
			player.fumefx.momx = player.mo.momx
			player.fumefx.momy = player.mo.momy
			player.fumefx.momz = player.mo.momz
			player.fumefx.dontdrawforviewmobj = player.mo
		end
		
		for i = 1,2,1 do
			local bostghost = P_SpawnGhostMobj(player.mo)
			bostghost.color = SKINCOLOR_ORANGE
			bostghost.blendmode = AST_ADD
		end
		player.pflags = $1 & ~PF_SPINNING
		player.elecharge = $ - 5
		if player.c1released or player.elecharge <= 4 then
			player.boostin = false
		end
		
	else
		if player.fumefx and player.fumefx.valid then
			P_KillMobj(player.fumefx,player.fumefx,player.fumefx)
			player.fumefx = nil
		end
	end
	if player.boostin then
		player.camerascale = player.mo.scale * 4 / 3
	else
		player.camerascale = player.mo.scale
	end
	/*if (player.cmd.buttons & BT_CUSTOM2) then -- for debugging the boost
		player.elecharge = 500
	end*/
end)

addHook("MobjThinker", function(mo)
	mo.scale = $ / mo.sizedec * mo.sizemult
end, MT_RUBYFUME)

addHook("PlayerCanDamage", function(player)
	if player.mo.skin ~= "ruby" then
		player.otherskin = true
		return
	end
	
	if player.boostin then
		return true
	end
	if player.hominged then
		return true
	end
end)


local function rubyhomingcollide(player,target)
	if target.player then
		if target.player.skin == "ruby" then
			targer = target
			target = player
			player = targer
		end
	end
	if player.valid and target and target.valid
		if not ( (player.z > target.z+target.height)
		or (target.z > player.z+player.height) )
			if player.skin == "ruby" then
				if player.player.hominged and target == player.player.target
					player.player.hominged = false
					player.player.doublejumped = false
					player.player.pflags = $1 & ~PF_THOKKED
					player.momx = $ / 4
					player.momy = $ / 4
					player.momz = player.scale * 10*P_MobjFlip(player)
					player.state = S_PLAY_JUMP
					if (player.eflags & MFE_UNDERWATER) then
						player.momz = $ / 2
					end
					player.player.powers[pw_nocontrol] = 0
				end
				if target.type == MT_RING then
					player.player.elecharge = $ + 5
				end
				if target.type == MT_YELLOWSPRING or target.type == MT_REDSPRING or target.type == MT_BLUESPRING then
					player.player.stompin = false
				end
			end
		end
	end
end

addHook("MobjDamage", function(target,inflictor,source)
	if ((target.flags & MF_ENEMY) or (target.flags & MF_BOSS)) and source.player then
		if source.skin == "ruby" then
			if P_IsObjectOnGround(source.player.mo) and source.player.punchpause > 0 then
				source.player.elecharge = $ + 50
			else
				source.player.elecharge = $ + 20
			end
			if source.player.elecharge > 500 then
				source.player.elecharge = 500
			end
		end
	end
end)

addHook("MobjCollide", rubyhomingcollide, MT_PLAYER)
addHook("MobjMoveCollide", rubyhomingcollide, MT_PLAYER)

local function CheckAndCrumble(mo, sec) -- gotten from srb2 servre
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
    if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

    EV_CrumbleChain(fof) -- Crumble
  end
end

addHook("MobjSpawn", function(mo)
	mo.lifetime = 7
end, MT_PUNCHHITBOX)
addHook("MobjThinker", function(mo)
	mo.angle = mo.owner.angle
	P_SetOrigin(mo, mo.owner.x + cos(mo.angle)*20, mo.owner.y + sin(mo.angle)*20, mo.owner.z)
	mo.momx = mo.owner.momx
	mo.momy = mo.owner.momy
	mo.momz = mo.owner.momz
	mo.lifetime = $ - 1
	CheckAndCrumble(mo,mo.subsector.sector)
	if mo.lifetime <= 0 then
		P_KillMobj(mo)
	end
end, MT_PUNCHHITBOX)
addHook("MobjMoveCollide", function(thing,tmthing)
	if thing.valid and tmthing.valid
		if not ( (thing.z > tmthing.z+tmthing.height)
		or (tmthing.z > thing.z+thing.height) )
			if thing.owner.skin == "ruby" then
				if (tmthing.flags & MF_SHOOTABLE) or (tmthing.flags & MF_ENEMY) or (tmthing.flags & MF_BOSS) then
					P_DamageMobj(tmthing,thing,thing.owner,1)
				else
					if tmthing.type == MT_SPIKE then
						P_KillMobj(tmthing,thing,thing.owner)
					end
				end
			end
		end
	end
end, MT_PUNCHHITBOX)

addHook("MobjSpawn", function(mo)
	mo.oldmomx = mo.momx
	mo.oldmomy = mo.momy
	mo.oldmomz = mo.momz
	mo.scale = FRACUNIT / 8
end, MT_ELECBALL)
addHook("MobjThinker", function(mo)
	if mo.momx ~= mo.oldmomx or mo.momy ~= mo.oldmomy or mo.momz ~= mo.oldmomz then
		P_KillMobj(mo)
	end
	
	if mo.valid then
		/*if mo.targer ~= nil then
			mo.angle = R_PointToAngle2(mo.x,mo.y,mo.targer.x,mo.targer.y)
			mo.vangle = R_PointToAngle2(0,mo.z,FixedHypot(mo.targer.x-mo.x,mo.targer.y-mo.y),mo.targer.z)
			mo.momx = 90 * FixedMul(cos(mo.angle), cos(mo.vangle))
			mo.momy = 90 * FixedMul(sin(mo.angle), cos(mo.vangle))
			mo.momz = 90 * sin(mo.vangle)
		end*/
		
		mo.oldmomx = mo.momx
		mo.oldmomy = mo.momy
		mo.oldmomz = mo.momz
		
		mo.scale = $ + FRACUNIT / 24
	end
end, MT_ELECBALL)
addHook("MobjMoveCollide", function(thing,tmthing)
	if thing.valid and tmthing.valid
		if not ( (thing.z > tmthing.z+tmthing.height)
		or (tmthing.z > thing.z+thing.height) )
			if thing.owner.skin == "ruby" then
				if (tmthing.flags & MF_SHOOTABLE) or (tmthing.flags & MF_ENEMY) or (tmthing.flags & MF_BOSS) then
					P_DamageMobj(tmthing,thing,thing.owner,1)
				else
					if tmthing.type == MT_SPIKE then
						P_KillMobj(tmthing,thing,thing.owner)
					end
				end
				return false
			end
		end
	end
end, MT_ELECBALL)

addHook("MobjDeath", function(target)
	local deathpart = P_SpawnMobjFromMobj(target,0,0,0,MT_IVSP)
	deathpart.destscale = target.scale * 4
	deathpart.scale = deathpart.destscale
	S_StartSound(mo,sfx_rblsr3)
	target.state = S_XDEATHSTATE
end, MT_ELECBALL)


hud.add(function(v, player)
	if player.mo.skin ~= "ruby" then
		return
	end
	local screenwidth = v.width()/v.dupx()
	local screenheight = v.height()/v.dupy()
	v.draw(screenwidth-10,175,v.cachePatch("ELECBAR"))
	v.drawFill(screenwidth-15,148-player.elecharge/5,9,player.elecharge/5,73)
end, "game")

// print("text") //(just a note to self)